/*
 * Thomas Keck 2017
 */

#pragma once

#define PyShellCode_VERSION_MAJOR 1
#define PyShellCode_VERSION_MINOR 0

#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>


struct ExecutableCode {
    size_t length;
    void *addr;
};


struct ExecutableCode* create_ExecutableCode_from_File(const char *filename);
struct ExecutableCode* create_ExecutableCode_from_ShellCode(const char *shellcode, size_t length);
int valid_ExecutableCode(struct ExecutableCode* code);
int64_t execute_ExecutableCode(struct ExecutableCode* code);
int64_t execute_with_void_ptr_ExecutableCode(struct ExecutableCode* code, void *arguments);
void destroy_ExecutableCode(struct ExecutableCode* code);
void print_ExecutableCode(struct ExecutableCode* code);

void PrintVersion(void);
